#ifndef CIRC8_CPP
#define CIRC8_CPP

#ifdef _WIN32
        #include <windows.h>
	#include <shlobj.h>
#endif
                
#include "circuit8.h"

Circuit8* Circuit8::Instance()
{
   static Circuit8 t;
   return &t;
}

Circuit8::Circuit8()
{
	screenidx = 0;
	upscrolls = 0;
//	cout << screenidx << endl;
	int ctr = screenidx;
	for (ctr = 0; ctr < 1026; ctr++) {
//		cout << screenidx << endl;
		for (int i = 0;i<65;i++) {
			for (int p = 0;p<49;p++) {
//				cout << ctr << i << p << endl;
				screen.screen[i][p].r[ctr] = 0;
				screen.screen[i][p].g[ctr] = 0;
				screen.screen[i][p].b[ctr] = 0;
			}
		}
	}
	screenidx = 32;
	screendirection = 1;
	framecoloffset = 0;
}

void Circuit8::moreRed(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge morered amount (nan?) : " << amount << endl; } else if (amount < 0) { cout << "negative morered amount (nan?): " << amount << endl; }
	screen.screen[x][y].r[screenidx] += amount;
	if (screen.screen[x][y].r[screenidx] > 1.0f) screen.screen[x][y].r[screenidx] = 1.0f;
}

void Circuit8::lessRed(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge lessred amount (nan?) : " << amount << endl; } else if (amount < 0) { cout << "negative lessred amount (nan?): " << amount << endl; }
	screen.screen[x][y].r[screenidx] -= amount;
	if (screen.screen[x][y].r[screenidx] < 0) screen.screen[x][y].r[screenidx] = 0;
}

void Circuit8::moreGreen(unsigned int x, unsigned int y, float amount)
{
	// flamount
	if (amount > 1.0f) { cout << "huge moregreen amount (nan?) : " << amount << endl; } else if (amount < 0) { cout << "negative moregreen amount (nan?): " << amount << endl; }
	screen.screen[x][y].g[screenidx] += amount;
	if (screen.screen[x][y].g[screenidx] > 1.0f) screen.screen[x][y].g[screenidx] = 1.0f;
}

void Circuit8::lessGreen(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge lessgreen amount (nan?) : " << amount << endl; } else if (amount < 0) { cout << "negative lessgreen amount (nan?): " << amount << endl; }
	screen.screen[x][y].g[screenidx] -= amount;
	if (screen.screen[x][y].g[screenidx] < 0) screen.screen[x][y].g[screenidx] = 0;
}

void Circuit8::moreBlue(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge moreblue amount (nan?) : " << amount << endl; } else if (amount < 0) { cout << "negative moreblue amount (nan?): " << amount << endl; }
	screen.screen[x][y].b[screenidx] += amount;
	if (screen.screen[x][y].b[screenidx] > 1.0f) screen.screen[x][y].b[screenidx] = 1.0f;
}

void Circuit8::lessBlue(unsigned int x, unsigned int y, float amount)
{
	if (amount > 1.0f) { cout << "huge lessblue amount (nan?) : " << amount << endl; } else if (amount < 0) { cout << "negative lessblue amount (nan?): " << amount << endl; }
	screen.screen[x][y].b[screenidx] -= amount;
	if (screen.screen[x][y].b[screenidx] < 0) screen.screen[x][y].b[screenidx] = 0;
}

Circuit8::~Circuit8()
{
}

#endif