#ifndef CRITTERVIEW_H
#define CRITTERVIEW_H

#include "panel.h"
#include "../entities/worldb.h"
#include "../../utils/critterselection.h"
#include "../../math/vector2f.h"
#include "../entities/critterb.h"

using namespace std;

class Critterview : public Panel
{
	struct neuron
	{
		NeuronInterz* nPointer;
		ArchNeuronz* anPointer;
		Vector2f position;
	};
	
	struct sensor
	{
		sensorNeuron* sPointer;
		Vector2f position;
	};

	public:
		Critterview();
		~Critterview();

		void draw();
		WorldB*		world;
	private:
		Critterselection* critterselection;
		Widget* viewbutton;
		Widget* vcortexbutton;
		Widget* pcortexbutton;
		Widget* bviewbutton;
		btScalar viewposition[16];
		CritterB* currentCritter;

		int circuit8screenheight;
		int circuit8screenwidth;

		float vcortex[96][96][3]; // if you move the psychic screen inputs up to make the retina larger, increase this too 
		float pcortex[64][48][3]; // if you change the size of the psychic screen, grow this as well

		vector<neuron> neurons;
		vector<sensor> sensors;
};

#endif
